ghcide-2.4.0.0: The core of an IDE

Safe Haskell | Safe-Inferred
Language | Haskell2010

Development.IDE.LSP.LanguageServer

# Documentation

runLanguageServer :: forall config a m. Show config => Recorder (WithPriority Log) -> Options -> Handle -> Handle -> config -> (config -> Value -> Either Text config) -> (config -> m config ()) -> (MVar () -> IO (LanguageContextEnv config -> TRequestMessage Method_Initialize -> IO (Either ResponseError (LanguageContextEnv config, a)), Handlers (m config), (LanguageContextEnv config, a) -> m config <~> IO)) -> IO () #

setupLSP #

Arguments

:: forall config err. Recorder (WithPriority Log) |
-> (FilePath -> IO FilePath) | Map root paths to the location of the hiedb for the project
-> Handlers (ServerM config) |
-> (LanguageContextEnv config -> Maybe FilePath -> WithHieDb -> IndexQueue -> IO IdeState) |
-> MVar () |
-> IO (LanguageContextEnv config -> TRequestMessage Method_Initialize -> IO (Either err (LanguageContextEnv config, IdeState)), Handlers (ServerM config), (LanguageContextEnv config, IdeState) -> ServerM config <~> IO) |

data Log #

Constructors

LogRegisteringIdeConfig !IdeConfiguration |
LogReactorThreadException !SomeException |
LogReactorMessageActionException !SomeException |
LogReactorThreadStopped |
LogCancelledRequest !SomeLspId |
LogSession Log |
LogLspServer LspServerLog |

#### Instances

Instances details

Show Log # |
Instance details Defined in Development.IDE.LSP.LanguageServer Methods showsPrec :: Int -> Log -> ShowS # show :: Log -> String # showList :: [Log] -> ShowS #
Pretty Log # |
Instance details Defined in Development.IDE.LSP.LanguageServer Methods pretty :: Log -> Doc ann # prettyList :: [Log] -> Doc ann #